/*
  Render to vertex array class
  sgreen 2/2004
*/

#ifndef RENDERVERTEXARRAY_H
#define RENDERVERTEXARRAY_H

#if defined(WIN32)
#  include <windows.h>
#endif
#include <GL/gl.h>

class RenderVertexArray {
public:
  RenderVertexArray(GLuint index, int nverts, GLint size);
  ~RenderVertexArray();

  void LoadData(void *data);                // load vertex data from memory
  void Read(GLenum buffer, int w, int h);   // read vertex data from frame buffer
  void SetPointer();

private:
    GLenum m_usage;     // vbo usage flag
    GLuint m_buffer;
    GLuint m_index;
    GLuint m_nverts;
    GLint m_size;       // size of attribute       
    GLenum m_format;    // readpixels image format
};

#endif
