#ifndef _MOVIEMAKER_H
#define _MOVIEMAKER_H

//  ===============================================
//  MovieMaker class definition.
//  ===============================================

#ifndef _WIN32

// Dummy implementations for non-Windows systems.
void SnapshotBMP(const char* bmpFileName) {}

class MovieMaker {
public:
	MovieMaker() {}
	~MovieMaker() {}

    inline bool IsOK() const { return true; };
	void StartCapture( char const* name, unsigned int dwFPS = 15 ) {}
	void EndCapture() {}
	bool Snap() { return true; }
};

#else // _WIN32

#include <windows.h>
#include <vfw.h>

void SnapshotBMP(const char* bmpFileName);

#define TEXT_HEIGHT	20
#define AVIIF_KEYFRAME	0x00000010L // this frame is a key frame.
#define BUFSIZE 260

class MovieMaker {
private:
    //CString FName;
    char fname[64];
    int width;
    int height;

  	AVISTREAMINFO strhdr;
	PAVIFILE pfile;
	PAVISTREAM ps;
	PAVISTREAM psCompressed;
	PAVISTREAM psText;
	AVICOMPRESSOPTIONS opts;
	AVICOMPRESSOPTIONS FAR * aopts[1];
	DWORD dwTextFormat;
	char szText[BUFSIZE];
	int nFrames;
	bool bOK;

    DWORD dwFPS;

public:
    MovieMaker();
    ~MovieMaker();

    inline bool IsOK() const { return bOK; };
    void StartCapture( char const* name, DWORD dwFPS = 15 );
    void EndCapture();
    bool Snap();
};

#endif
#endif
